<script type="text/html" data-help-name="dim-value-client">
  <p>
    A DIM Client node to subscribe a service on a DIM Service Provider (DIS).
  </p>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">string | number | array</span></dt>
    <dd>The service value received.</dd>
    <dt class="optional">
      timestamp<span class="property-type">number</span>
    </dt>
    <dd>The value's UNIX timestamp in millisecs.</dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node must be configured with the name of the service to be subscribed
    to and a connection to the the DIM Name Server (DNS) hosting that service.
    For the latter, it is possible to either create a new DNS Server connection
    by clicking on the pencil icon or use an existing one shared between
    several DIM nodes.
  </p>
  <p>
    The node can retrieve the list of the services registered on the DNS Server
    set-up. For each service in the drop-down list, the required input
    parameters are shown according to the following
    <a target="_blank" href="https://www.rfc-editor.org/info/rfc5234">
      abnf syntax
    </a>:
  </p>
  <pre><b>*(type ":" num ";") type [":" num]</b>
    <br>type = "C" / "S" / "I" / "X" / "F" / "D"
    <br>num = 1*DIGIT</pre>
  <p>
    where types are:
    <table style="outline-width:#888 solid thin">
      <tr><th width="50px">type</th><th width="80px">description</th></tr>
      <tr><td><center>C</center></td><td><center>string</center></td></tr>
      <tr><td><center>S</center></td><td><center>int16</center></td></tr>
      <tr><td><center>I</center></td><td><center>int32</center></td></tr>
      <tr><td><center>X</center></td><td><center>int64</center></td></tr>
      <tr><td><center>F</center></td><td><center>float</center></td></tr>
      <tr><td><center>D</center></td><td><center>double</center></td></tr>
    </table>
  </p>
  <p>
    By default, the node is configured to retrieve the service value manually,
    by clicking on its button within the editor. It can also be set to monitor
    a value, get the value with a given schedule or both. In particular, with
    the option:
    <ul>
      <li><b>Monitored</b>, if enabled, the node receives a service value when
        updated server side.
      <li><b>Scheduled</b>, if enabled, the node receives a service value at a
        regular time intervals defined by the <i>Every</i> field. The time
        interval is equal to 1000 millisecs by default.
    </ul>
  </p>
  <p>
    The first service value is received upon subscription, which is the current
    service value or an empty one if it is not set.
  </p>
  <p>
    It is also possible to request service values with additional timestamp
    information by selecting the <b>Stamped</b> option. Thus, the value's
    timestamp is saved in the <code>msg.timestamp</code> property.
  </p>
</script>

<script type="text/html" data-help-name="dim-json-client">
  <p>
    A DIM Client node to subscribe a JSON service on a DIM Service Provider
    (DIS).
  </p>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>
      payload
      <span class="property-type">
        string | number | boolean | array | object
      </span>
    </dt>
    <dd>
      The received JSON string parsed.
    </dd>
    <dt class="optional">
      timestamp<span class="property-type">number</span>
    </dt>
    <dd>The value's UNIX timestamp in millisecs.</dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node is a specialisation of the <code>DIM Value Client</code> node as
    it can only subscribe to services that publish JSON strings.
  </p>
  <p>
    For further details, see <code>DIM Value Client</code> node.
  </p>

</script>
